/*
  Copyright (c) 2011 Arduino.  All right reserved.

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef _VARIANT_ARDUINO_STM32_
#define _VARIANT_ARDUINO_STM32_

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus


#define PA0                     A0
#define PA1                     A1
#define PA2                     A2
#define PA3                     A3
#define PA4                     A4
#define PA5                     A5
#define PA6                     A6
#define PA7                     A7
#define PA8                     8
#define PA9                     9
#define PA10                    10
#define PA11                    11
#define PA12                    12
#define PA13                    13
#define PA14                    14
#define PA15                    15
#define PB0                     A8
#define PB1                     A9
#define PB2                     18
#define PB3                     19
#define PB4                     20
#define PB5                     21
#define PB6                     22
#define PB7                     23
#define PB8                     24
#define PB9                     25
#define PB10                    26
#define PB12                    27
#define PB13                    28
#define PB14                    29
#define PB15                    30
#define PC0                     A10
#define PC1                     A11
#define PC2                     A12
#define PC3                     A13
#define PC4                     A14
#define PC5                     A15
#define PC6                     37
#define PC7                     38
#define PC8                     39
#define PC9                     40
#define PC10                    41
#define PC11                    42
#define PC12                    43
#define PC13                    44
#define PC14                    45
#define PC15                    46
#define PD0                     47
#define PD1                     48
#define PD2                     49
#define PD3                     50
#define PD4                     51
#define PD5                     52
#define PD6                     53
#define PD7                     54
#define PD8                     55
#define PD9                     56
#define PD10                    57
#define PD11                    58
#define PD12                    59
#define PD13                    60
#define PD14                    61
#define PD15                    62
#define PE0                     63
#define PE1                     64
#define PE2                     65
#define PE3                     66
#define PE4                     67
#define PE5                     68
#define PE6                     69
#define PE7                     70
#define PE8                     71
#define PE9                     72
#define PE10                    73
#define PE11                    74
#define PE12                    75
#define PE13                    76
#define PE14                    77
#define PE15                    78
#define PH0                     79
#define PH1                     80

// This must be a literal
#define NUM_DIGITAL_PINS        81
#define NUM_ANALOG_INPUTS       16

// On-board LED pin number
//#ifndef LED_BUILTIN
//#define LED_BUILTIN             PA5
//#endif
//#define LED_GREEN               LED_BUILTIN

// On-board user button
// #ifndef USER_BTN
// #define USER_BTN                PC13
// #endif

// I2C definitions
#define PIN_WIRE_SDA            PC9
#define PIN_WIRE_SCL            PA8

// Timer Definitions
#define TIMER_TONE              TIM10
#define TIMER_SERVO             TIM11

// UART Definitions
#define SERIAL_UART_INSTANCE    2

// Default pin used for 'Serial' instance
// Mandatory for Firmata
#define PIN_SERIAL_RX           PC7
#define PIN_SERIAL_TX           PC6

#define HSE_VALUE               25000000U

#ifdef __cplusplus
} // extern "C"
#endif
/*----------------------------------------------------------------------------
 *        Arduino objects - C++ only
 *----------------------------------------------------------------------------*/

#ifdef __cplusplus
  // These serial port names are intended to allow libraries and architecture-neutral
  // sketches to automatically default to the correct port name for a particular type
  // of use.  For example, a GPS module would normally connect to SERIAL_PORT_HARDWARE_OPEN,
  // the first hardware serial port whose RX/TX pins are not dedicated to another use.
  //
  // SERIAL_PORT_MONITOR        Port which normally prints to the Arduino Serial Monitor
  //
  // SERIAL_PORT_USBVIRTUAL     Port which is USB virtual serial
  //
  // SERIAL_PORT_LINUXBRIDGE    Port which connects to a Linux system via Bridge library
  //
  // SERIAL_PORT_HARDWARE       Hardware serial port, physical RX & TX pins.
  //
  // SERIAL_PORT_HARDWARE_OPEN  Hardware serial ports which are open for use.  Their RX & TX
  //                            pins are NOT connected to anything by default.
  #define SERIAL_PORT_MONITOR     Serial
  #define SERIAL_PORT_HARDWARE    Serial
#endif

#endif /* _VARIANT_ARDUINO_STM32_ */
